int speed=80;
int rotate=0;
int time_flag=1;
int prev_ir=0;	/*previouse IR test value*/
float temp_time=1000.;

void real_drive ()	/* tell motors to drive, rotate or stop */
{
int i, delta=0;

while (1) 
	{
	drive (speed, rotate);
	defer();
	}
}

void detect_ir ()		/* check subjects in front, left or right and avoid */
{
int bumper_status=0;
int cur_ir;

while (1)
{
if (time_flag==1)
   {
	bumper_status=bumper();
	if (bumper_status!=0 && bumper_status!=4) step_back ();
	else
			{
	cur_ir = ir_detect();
      if (cur_ir == 0b00)										/* Clear */
	{
		if (temp_time==1000.)	temp_time=seconds();
		else
		{
		if ((seconds()-temp_time)>6.)		/* change slightly direction after 6 sec pass */
			{
			if (analog(microphone)%2)		rotate=100;
			else						rotate=-100;
			sleep(.5);
			rotate=0;
			temp_time=1000.;
			}
		else	{printf("GO BABY GO!\n"); sleep(0.5);}	
		}
	}			
      else
	if (cur_ir == 0b11)	 step_back();							/* Both */
      else
	{
	prev_ir=cur_ir;	/*remember prev turn*/
	if (cur_ir == 0b10)	{rotate=-100; tone (100.,.1); printf("TURN RIGHT\n");}/* Left */

     	else	{rotate=100; tone (150.,.1); printf("TURN LEFT\n");}				/* Right */
	sleep(.25);
	temp_time=1000.;
	}
			}
      speed=80;
	rotate=0;
	sleep(.15);
   }
	defer();
}}


void step_back ()
{
		speed=0; 
		printf("STEP BACK\n");
		tone (150.,.15); tone (100.,.1); sleep(1.);
		speed=-70; sleep(.75); speed=0;
		if (prev_ir==0){
			if (analog(microphone)%2)		rotate=100;		/* use analoge(mic) to get rundome 0 or 1 value */
			else						rotate=-100;}
		else{
		if (prev_ir == 0b10)				rotate=-100; 
		else							rotate=100;}

		prev_ir=0;
		sleep(.25);
		rotate=0;
		temp_time=1000.;
}


void detect_clicks()	/* detects and avoid touch sensors */
{
int rcl, lcl;
while (1)
{
rcl=get_right_clicks();
lcl=get_left_clicks();
sleep(0.25);

if ((rcl == get_right_clicks() | lcl == get_left_clicks()) && time_flag==1)	step_back ();
defer();
}}

void check_time()		/* sleeps after 200 sec activity */
{
while (1)
{
if (seconds()>200.)
	{
time_flag=0;
charge(); 
printf("SLEEP...!\n");
speed=0;
rotate=0;
sleep(3.);
while ((analog(2)>80 && analog(2)<170) ) 	speed=0;	/* waik up upon loud sound occured */
charge(); 
reset_system_time();
time_flag=1;
	}
defer();
}}

void charge()
{
tone (100.,.1); tone (150.,.2); tone (200.,.3);
}

void avoid_darkness()		/* check if it is too dark, seek for more light anf goes, if not- sleeps */
{
int right_photo=255;
float rot_time;
while (1)
{
	if (analog(photo_right)>240)
	{
	time_flag=0;
	tone (100.,.1);tone (75.,.2);tone (50.,.3);
	speed=0;
	rotate=0;
	sleep(1.);
	rotate=-70;
	rot_time=seconds();
	while ((seconds()-rot_time)<3.5)		/*rotate 3.5 sec to seek more light*/
		{
		if(analog(photo_right)<right_photo)		right_photo=analog(photo_right);
		}

	if ((240-right_photo)<=5)			/*check for still dark?*/
		{
		rotate=0; sleep(1.);
		while ((analog(photo_right)>220))	 reset_system_time();
		}				
	else	
		{
		while ((analog(photo_right)-right_photo)>3)
			{tone (50.,.01);}
		}
	sleep(.8);
	rotate=0;
	sleep(1.);
	time_flag=1;
	right_photo=255;
	temp_time=1000.;
	}
	defer();
}
}

void main()
{
printf("HELLO MASTER!\n");
sleep(7.);
init_motors();
init_velocity();
charge();
reset_system_time();

/* proceed to start processes */

start_process(check_time());
start_process(real_drive());
start_process(detect_ir());
/*start_process(detect_clicks());*/
start_process (avoid_darkness());
}